+   [安装 scikit-learn](79.md)
+   用户指南
    +   [1\. 监督学习](1.md)
        +   [1.1\. 广义线性模型](2.md)
        +   [1.2\. 线性和二次判别分析](3.md)
        +   [1.3\. 内核岭回归](4.md)
        +   [1.4\. 支持向量机](5.md)
        +   [1.5\. 随机梯度下降](6.md)
        +   [1.6\. 最近邻](7.md)
        +   [1.7\. 高斯过程](8.md)
        +   [1.8\. 交叉分解](9.md)
        +   [1.9\. 朴素贝叶斯](10.md)
        +   [1.10\. 决策树](11.md)
        +   [1.11\. 集成方法](12.md)
        +   [1.12\. 多类和多标签算法](13.md)
        +   [1.13\. 特征选择](14.md)
        +   [1.14\. 半监督学习](15.md)
        +   [1.15\. 等式回归](16.md)
        +   [1.16\. 概率校准](17.md)
        +   [1.17\. 神经网络模型（有监督）](18.md)
    +   [2\. 无监督学习](19.md)
        +   [2.1\. 高斯混合模型](20.md)
        +   [2.2\. 流形学习](21.md)
        +   [2.3\. 聚类](22.md)
        +   [2.4\. 双聚类](23.md)
        +   [2.5\. 分解成分中的信号（矩阵分解问题）](24.md)
        +   [2.6\. 协方差估计](25.md)
        +   [2.7\. 经验协方差](26.md)
        +   [2.8\. 收敛协方差](27.md)
        +   [2.9\. 稀疏逆协方差](28.md)
        +   [2.10\. Robust 协方差估计](29.md)
        +   [2.11\. 新奇和异常值检测](30.md)
        +   [2.12\. 密度估计](31.md)
        +   [2.13\. 神经网络模型（无监督）](32.md)
    +   [3\. 模型选择和评估](33.md)
        +   [3.1\. 交叉验证：评估估算器的表现](34.md)
        +   [3.2\. 调整估计器的超参数](35.md)
        +   [3.3\. 模型评估: 量化预测的质量](53.md)
        +   [3.4\. 模型持久化](54.md)
        +   [3.5\. 验证曲线: 绘制分数以评估模型](55.md)
    +   [4\. 数据集转换](56.md)
        +   [4.1\. Pipeline（管道）和 FeatureUnion（特征联合）: 合并的评估器](57.md)
        +   [4.2\. 特征提取](58.md)
        +   [4.3\. 预处理数据](59.md)
        +   [4.4\. 无监督降维](60.md)
        +   [4.5\. 随机投影](61.md)
        +   [4.6\. 内核近似](62.md)
        +   [4.7\. 成对的矩阵, 类别和核函数](63.md)
        +   [4.8\. 预测目标 (`y`.md) 的转换](64.md)
    +   [5\. 数据集加载工具](65.md)
    +   [6\. 大规模计算的策略: 更大量的数据](66.md)
    +   [7\. 计算性能](67.md)
+   教程
    +   [使用 scikit-learn 介绍机器学习](68.md)
    +   [关于科学数据处理的统计学习教程](69.md)
    +   [机器学习: scikit-learn 中的设置以及预估对象](70.md)
    +   [监督学习：从高维观察预测输出变量](71.md)
    +   [模型选择：选择估计量及其参数](72.md)
    +   [无监督学习: 寻求数据表示](73.md)
    +   [把它们放在一起](74.md)
    +   [寻求帮助](75.md)
    +   [处理文本数据](76.md)
    +   [选择正确的评估器(estimator.md)](77.md)
    +   [外部资源，视频和谈话](78.md)
+   [API 参考](https://scikit-learn.org/stable/modules/classes.html)
+   [常见问题](80.md)
+   [时光轴](81.md)